﻿Type=Class
Version=5.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private sock As Socket
	Private const Port As Int = 54025
	Private astream As AsyncStreams
	Public bmp As Bitmap
	Dim bc As ByteConverter
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	TryToConnect
End Sub

Private Sub TryToConnect
	sock.Initialize("sock")
	sock.Connect(Main.DesktopIp, Port, 10000)
End Sub

Private Sub sock_Connected (Successful As Boolean)
	If Successful Then
		Log("TCP Connected")
		astream.InitializePrefix(sock.InputStream, False, sock.OutputStream, "astream")
	Else
		Starter.CallSubUtils1.CallSubPlus(Me, "TryToConnect", 3000)
	End If
End Sub

Public Sub SendCommand(data() As Byte)
	
	If sock.Connected = False Then
		LogColor("Not connected", Colors.Red)
		Return
	End If
	astream.Write(data)
End Sub

Private Sub astream_Terminated
	Log("TCP disconnected")
	astream.Close
	Starter.CallSubUtils1.CallSubPlus(Me, "TryToConnect", 3000)
End Sub

Private Sub astream_Error
	astream_Terminated
End Sub

Sub astream_NewData (Buffer() As Byte)
	Dim InputStream1 As InputStream
	InputStream1.InitializeFromBytesArray(Buffer, 0, Buffer.Length)
	bmp.Initialize2(InputStream1)
	CallSub(Main,"picture")
End Sub 

Sub zoom(st As String)
	Dim buffer() As Byte = bc.StringToBytes(st, "utf8")
	astream.Write( buffer)
End Sub